<template>
    <v-container class="pasta text-center" style="margin-top: 60px">
        <v-simple-table>
            <template v-slot:default>
                <thead>
                <tr>
                    <th></th>
                    <th v-for="col in model.cols" :key="col"
                        class="text-center font-weight-bold headline">
                        {{ col }}
                    </th>
                </tr>
                </thead>
                <tbody>
                <tr v-for="row in model.rows" :key="row.title">
                    <td class="text-center text-h6">
                        {{ row.title }}
                    </td>
                    <th v-for="col in model.cols" :key="row.title + col" class="text-center">
                        <v-select v-model="model.data[col][row.title]"
                                  :items="row.data"
                                  outlined dense hide-details/>
                        {{ model.data[col][row] }}
                    </th>
                </tr>
                </tbody>
            </template>
        </v-simple-table>
        <v-alert v-show="satisfiable != null"
                 :type="satisfiable ? 'success' : 'error'">
            {{ satisfiable ? "Well done, it's satisfiable" : "Sorry, it's not satisfiable" }}
        </v-alert>
        <v-btn @click="submit" color="success" class="mt-4">Submit</v-btn>
		<br /><br />
		<ul style="text-align: justify">
			<li>The woman wearing the White shirt is next to the woman who likes Lombardian wines.</li>
			<li>Ms Miller is somewhere between Ms Davis and Ms Brown, in that order.</li>
			<li>The youngest woman is at the third position.</li>
			<li>The 45 years old woman is somewhere to the right of the woman wearing the Red shirt.</li>
			<li>The woman who likes Chilean wines also likes Farfalle.</li>
			<li>At the first position is the woman that likes Argentine wines.</li>
			<li>Andrea is exactly to the right of the 35 years old woman.</li>
			<li>The woman wearing the Blue shirt is somewhere between Ms Davis and Holly, in that order.</li>
			<li>Victoria is next to Leslie.</li>
			<li>The woman wearing the Red shirt is somewhere to the left of the woman who likes Australian wines.</li>
			<li>Ms Wilson is next to the 30 years old woman.</li>
			<li>Leslie is exactly to the left of the 30 years old woman.</li>
			<li>Holly is somewhere to the right of the woman wearing the Red shirt.</li>
			<li>Ms Brown is exactly to the left of Julie.</li>
			<li>The youngest woman likes Penne.</li>
			<li>Ms Wilson is wearing the White shirt.</li>
			<li>The woman who likes Lasagne is somewhere between the woman who likes Italian wines and the woman who likes Spaghetti, in that order.</li>
			<li>At the second position is the woman wearing the Blue shirt.</li>
			<li>The 40 years old woman likes Lasagne.</li>
			<li>Ms Lopes is at the fifth position.</li>
			<li>The woman that likes Australian wines is somewhere between Victoria and the woman who likes wines from Bordeaux, in that order.</li>
			<li>The woman wearing the Yellow shirt is exactly to the left of the 35 years old woman.</li>
		</ul>
    </v-container>
</template>

<script>

import Services from "@/services";

export default {
    name: 'Pasta',
    data: () => ({
        satisfiable: null,
        model: {
            rows: [
                {
                    title: "Shirt",
                    data: ["blue", "green", "red", "white", "yellow"]
                },
                {
                    title: "Name",
                    data: ["Andrea", "Holly", "Julie", "Leslie", "Victoria"]
                },
                {
                    title: "Surname",
                    data: ["Brown", "Davis", "Lopes", "Miller", "Wilson"]
                },
                {
                    title: "Pasta",
                    data: ["Farfalle", "Lasagne", "Penne", "Spaghetti", "Ravioli"]
                },
                {
                    title: "Wine",
                    data: ["Australian", "Argentine", "Chilean", "French", "Italian"]
                },
                {
                    title: "Age",
                    data: ["30 years", "35 years", "40 years", "45 years", "50 years"]
                },
            ],
            cols: ["Woman #1", "Woman #2", "Woman #3", "Woman #4", "Woman #5"],
            data: {}
        }
    }),
    created() {
        for (let col of this.model.cols) {
            this.model.data[col] = {};
            for (let row of this.model.rows) {
                this.model.data[col][row.title] = "";
            }
        }
    },
    methods: {
        async submit() {
            let res = await Services.pb1(this.model.data);
            this.satisfiable = res.satisfiable;
        }
    }
}
</script>
